"""Preferences Application"""
import sys
import time

import BApplication
from AppKit import *

from modules.constants import *
from modules.log import log
from window import PrefsWindow

# BeOS Application
class MainApp(BApplication.BApplication):
	def __init__(self, sig):
		BApplication.BApplication.__init__(self, sig)

	def ReadyToRun(self):
		self.win = PrefsWindow()
		self.win.Show()

	def MessageRecevied(self, msg):
		if msg.what == B_SILENT_RELAUNCH:
			self.win.Activate(True)

# Main
def main():
	# Start the App	
	ThisApp = MainApp(SIG_PREFERENCES)
	try:
		ThisApp.Run()
	except:
		trace = traceback.extract_stack()[-2]
		msg = '%s() [%s:%i]' % (trace[FUNCNAME], os.path.split(trace[FILENAME])[-1], trace[LINENO])
		log(msg)
		modules.ui.ErrorBox(msg, True)
		try:
			# try to quit cleanly
			ThisApp.PostMessage(B_QUIT_REQUSTED)
		except:
			pass

# Do the Mario
if __name__ == '__main__':
	main()
